Subject: Re: empty directories and git

From: Jakub Narebski <[email-masked]>
Date: Thu, 16 Sep 2010 13:02:19 -0700 (PDT)

Kevin Ballard <[email-masked]> writes:
> On Sep 16, 2010, at 1:32 AM, Andreas Ericsson wrote:
> 
> > You can't have empty directories in git.

> Apologies to those who were CC'd on the original message, I'm
> resending to this list as I forgot to set plain text.
> 
> I've always wondered about that. Why do we still have this
> restriction? There is a sha1 hash that is equivalent to the empty
> tree (4b825dc642cb6eb9a060e54bf8d69288fbee4904). Why can't git just
> use that to represent an empty directory? I imagine things that
> touch the working copy may need to be updated to be aware of this,
> but the problem doesn't seem insurmountable.

If I understand it correctly the problem is that git index is flat
structure that contains only file (blob) info; there is currently no
place in it to store information that some empty directory was added.

Adding an extension to have directories in index was considered in the
past; it could even speed up git a bit, I think.
-- 
Jakub Narebski
Poland
ShadeHawk on #git